<?php

namespace App\Console;

use App\Services\BilibiliService;
use App\Services\CompressImageService;
use App\Services\XiuGirlsService;
use App\Services\VitabioticsService;
use App\Services\YouKnowService;
use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;
use App\Services\InstagramService;
use Illuminate\Support\Facades\Log;


class Kernel extends ConsoleKernel
{
    /**
     * The Artisan commands provided by your application.
     *
     * @var array
     */
    protected $commands = [
        //
    ];

    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule)
    {
        $schedule->call(function () {
            if ((rand(0, 99) % 2) == 0) {
                exit();
            }
            if(date('H') % 4 != 0) {
                Log::info("schedule queryUpVideoList skipped at: " .date("Y-m-d H:i:s"));
                exit;
            }
            $bilibili = new BilibiliService();
            Log::info("schedule queryUpVideoList started at: ". date("Y-m-d H:i:s"));
            $bilibili->queryUpVideoList();
        })->hourlyAt(5);
//    })->yearly();
        $schedule->call(function () {
            if ((rand(0, 99) % 2) == 1) {
                exit();
            }
            if(date('H') % 4 != 0) {
                Log::info("schedule queryDBCollectionList skipped at: " .date("Y-m-d H:i:s"));
                exit;
            }
            $bilibili = new BilibiliService();
            Log::info("schedule queryDBCollectionList started at: ". date("Y-m-d H:i:s"));
            $bilibili->queryDBCollectionList();
        })->hourlyAt(35);
//    })->yearly();
        $schedule->call(function () {
            $bilibili = new BilibiliService();
            Log::info("schedule compareAndDownloadUpVideos started at: ". date("Y-m-d H:i:s"));
            $bilibili->compareAndDownloadUpVideos();
        })->yearly();
        // $schedule->command('inspire')
        //          ->hourly();
        $schedule->call(function () {
            $service = new InstagramService();
            //            $service->scrapeLikedUsers();
            $service->scrapeUsers();

            //            $service = new VitabioticsService();
            //            $service->testPromoCode();

            //            $service->scrapeUsers();
            //            $service->scanLocalFiles();


            //             $xiuService = new XiuGirlsService();
            //             $xiuService->scrapeXiuGirls();

            //            $bilibili = new BilibiliService();
            //            $bilibili->queryUpVideoList();

            //            $bilibili->queryPlayList();
            //            $bilibili->downloadBSitePlaylist("av75454867 av75207675 av75065073 av74866823 av74764675 av74648540");
            //            $bilibili->deleteFileNotContainP();

            //            $youService = new YouKnowService();
            //            $youService->scrape1024();


            //            $compressService = new CompressImageService();
            //            $compressService->compressImage();
            echo "111";
//        })->everyMinute();
        })->dailyAt("00:10");

        $schedule->call(function () {
            $service = new InstagramService();
            $service->scrapeLikedUsers();
//        })->everyMinute();
        })->dailyAt('02:00');

        $schedule->call(function () {
            $xiuService = new XiuGirlsService();
            $xiuService->scrapeXiuGirls();
//        })->everyMinute();
        })->dailyAt('05:00');



//        $schedule->command("vitabiotics")
    }

    /**
     * Register the commands for the application.
     *
     * @return void
     */
    protected function commands()
    {
        $this->load(__DIR__.'/Commands');

        require base_path('routes/console.php');
    }
}
